#!/usr/bin/perl
########################
# - Scripted by CheRt[aka_GoDleSS]
# - (c) 2006 http://watchforyou.ru
# - v1.1.3 (X.Y.Z)
# - X - huge modification
# - Y - modified a little
# - Z - bugfixes
########################

# Loading STD libs
use CGI qw/param/;
#use strict; #Uncomment if you want. GuestBook can work with strict!

# Options part
my $non_cgi_dir='non-cgi';			#Full or party way to non-cgi dir (without end '/')
my $base="$non_cgi_dir/gb_base.dat";	#Guestbook database
my $smiles_pack_file="$non_cgi_dir/smiles.dat";	#Smiles control file "smile_text=smile_image"
my $ico_file="$non_cgi_dir/gb.ico";		#Favorite Icon (favicon)
my $css_file="$non_cgi_dir/style.css";		#Styles file

my $title='  ||  ';	#GB title
my $url_main='http://mysite.ru';		#Url to main page

my $post_at_page=10;			#Number of posts at one page
my $uname_maxsize=30;			#Max user name length
my $post_maxsize=16384;			#Max message length
my $word_maxsize=80;			#Max word length
my $posttime=10;				#Time in seconds between two posts from one IP
my $error_color='#A00000';			#Error messages color

my $top_message=qq~<small>
!    .<br>
      ,    .</small><br><br>~;

# Program part
my $error;

if (param('action') eq 'post') {
 printpost( $base, StripName(param('uname'),$uname_maxsize), StripPost(param('body'),$post_maxsize) );
}



showgb($base,$post_at_page,param('page'));

sub showgb {
 my ($file,$post_at_page,$pagenum)=@_;

 my $i=0;
 my $header="Content-type:text/html;Charset:windows-1251;\n\n";

 $pagenum=~s/[^\d]//g;
 unless($pagenum) {$pagenum=1;}
 
 open(DBF, $file);
  my @data=<DBF>;
 close(DBF);
 @data=reverse(@data);

 my $pages; my $temp;
 if (int(@data/$post_at_page)==@data/$post_at_page) {
  $temp=@data/$post_at_page;
 } else {
  $temp=int(@data/$post_at_page)+1;
 }

 if ($temp>1) {
  for ($i=0;$i<$temp;$i++) {
   $_=$i+1;
   if ($_==$pagenum) {
    $pages.=qq~ &nbsp; <font class="currentpage" title=" ">$_</font>~
   } else {
    $pages.=qq~ &nbsp; <a href="$ENV{'SCRIPT_NAME'}?page=$_">$_</a>~
   }
  }
  $pages=": $pages";
 }

print <<HTML;
$header
<html>
 <head>
  <title>$title [ - $pagenum]</title>
  <link rel="shortcut icon" href="$ico_file" type="image/x-icon"/>
  <meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
  <meta http-equiv="keywords" content="  ">
  <meta name="description" content=" .">
  <meta http-equiv="Cache-Control" content="no-cache">
  <link rel="stylesheet" href="$css_file">
 </head>
 <body>
<br>
<a href="$url_main">   </a>.
<br><br>$top_message
 &nbsp; $error
  <form method="POST" action="$ENV{'SCRIPT_NAME'}">
   <input type="hidden" name="page" value="$pagenum">
   <input type="hidden" name="action" value="post">

   <b>()</b> - <input type="text" name="uname" size="50" class="stdform"><br><br>
   <b>:</b><br>
   <textarea name="body" cols="80" rows="13"></textarea><br><br>
   <p class="lvl3"><input type="submit" value="" class="button"></p>
  </form>

  <div align="center" class="dashedline"></div>

  <br><br>$pages<br><br>
HTML

 my @buffer;
 for ($i=($pagenum-1)*$post_at_page;$i<$post_at_page*$pagenum;$i++) {
  @buffer=split(/\|/, $data[$i]);
  unless ($buffer[0]==0) {
	$buffer[0]=localtime($buffer[0]);
	$buffer[0]=~s/\s+/, /g;
	$buffer[3]=gb_smiles($buffer[3]);
   print qq~<p class="lvl2">[$buffer[0]] <b>$buffer[2]</b><br>$buffer[3]</p><br><br>\n\n~;
  }
 }

 print qq~<br>$pages<br><br></body></html>~;
}

sub printpost {
 my $file=shift;
 my $uname=shift;
 my $text=shift;

 my $ip=$ENV{'REMOTE_ADDR'};

 if (length($uname)>0 && length($text)>0) {
  open(DBF, $file);
   my @data=<DBF>;
  close(DBF);

  $_=pop(@data);
  @_=split(/\|/, $_);
  if ($ip eq $_[1] && (time()-$_[0])<$posttime) {
   $error="<font color=\"$error_color\">      !<br>  : ".($posttime-(time()-$_[0])).".</font>";
  } else {
   open(DBF, ">>$file");
    flock(DBF, 2);
    print DBF time(),"|$ip|$uname|$text\n";
   close(DBF);
  }
 } else {
  $error="<font color=\"$error_color\">      !</font>";
 }
}

sub StripName {
 my $uname=shift;
 my $size=shift;

 $uname=~s/[^a-z--0-9\.\-_\~\*#]//ig;
 $uname=substr($uname,0,$size);

 return $uname;
}

sub StripPost {
 my $text=shift;
 my $size=shift;
 my $temp;

 $text=substr($text,0,$size);

 $text=~s/</&lt;/g;
 $text=~s/>/&gt;/g;

 $text=~s/\n/ <br> /g;
 $text=~s/\r//g;
 $text=StripLongWords($text);
 $text=~s/\s{2,}/ /g;
 $text=~s/\|/\/g;

 return $text;
}

sub  StripLongWords {
 my $text=shift;

 my @buffer=split(/\s/, $text); $text='';

 foreach my $i(0..$#buffer) {
  if (length($buffer[$i])>$word_maxsize) {
   $buffer[$i]=substr($buffer[$i],0,$word_maxsize);
  }
  $text.=" $buffer[$i] ";
 }

 return $text;
}

sub gb_smiles {
 my $text=shift;

 open(SMP, $smiles_pack_file);
  while(<SMP>) {
   m/^([^=]+)=(.*)$/;
   @_=($1,$2);
   chomp($_[1]);
   $text=~s/\Q$_[0]/<img src="$non_cgi_dir\/smiles\/$_[1]" title="$_[0]">/ig;
  }
 close(SMP);

 return $text;
}
